/**
 * Dasu Project
 *
 * File:         DasuMain.java
 * RCS:          $Id: DasuMain.java,v 1.0 Aug 21, 2012 2:51:03 PM mas939 Exp $
 * Description:  DasuMain class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Aug 21, 2012 at 2:51:03 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2012, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.gudy.azureus2.plugins.PluginException;
import org.gudy.azureus2.plugins.PluginInterface;
import org.gudy.azureus2.plugins.UnloadablePlugin;

import edu.northwestern.dasu.util.DasuClassLoader;

/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The DasuMain class ...
 */
public class MainDasu implements UnloadablePlugin {

	private static ClassLoader dasuClassLoader = null;
	public static boolean DEBUG = true;
	static Object main = null;
	
	public void initialize(PluginInterface arg0) throws PluginException {

		dasuClassLoader = new DasuClassLoader(this.getClass().getClassLoader(), null);
		System.out.println("\n\n\n\n\n\n" + this.getClass().getClassLoader() + "\n\n\n\n\n\n");
		try {
			main = dasuClassLoader.loadClass("edu.northwestern.dasu.Main").newInstance();			

			for ( Method m : main.getClass().getMethods()) {
				if ( m.getName().equals("initialize") )
					m.invoke(main, arg0);
			}
			
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		
	}

	public void unload() throws PluginException {
		
		try {
			main.getClass().getMethod("unload", null).invoke(main, null);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	

}
