/**
 * Dasu Project
 *
 * File:         DistributedCoordinator.java
 * RCS:          $Id: DistributedCoordinator.java,v 1.0 Oct 1, 2012 4:47:07 PM mas939 Exp $
 * Description:  DistributedCoordinator class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Oct 1, 2012 at 4:47:07 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.coordination
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2012, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

package edu.northwestern.dasu.coordination;

import java.util.logging.Logger;

import edu.northwestern.dasu.measurement.tasks.ProbeTask.ProbeSubTask;
import edu.northwestern.dasu.measurement.types.SourceType;

/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The DistributedCoordinator class ...
 */
public abstract class DistributedCoordinator extends Thread {

	public SourceType engineId;
	private Float version;
	
	protected DistributedCoordinator(SourceType engineId, String namePrefix,
			Float version) {
		this.engineId = engineId;
		this.setName(namePrefix + engineId);
		this.version = version;
	}
	
	protected final static Logger LOGGER = Logger.getLogger("edu.northwestern.dasu");
	
	public abstract boolean schedulable(ProbeSubTask pst);
	
	public abstract void stopCoordinator();
	
	public Float getVersion() {
		return version;
	}
	
}