/**
 * Dasu Project
 *
 * File:         EnumClass.java
 * RCS:          $Id: EnumClass.java,v 1.0 Jul 22, 2012 11:00:56 PM mas939 Exp $
 * Description:  EnumClass class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Jul 22, 2012 at 11:00:56 PM
 * Language:     Java
 * Package:      edu.northwestern.zookeeper
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2012, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.dynamic.coordination;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;

import edu.northwestern.dasu.measurement.types.SourceType;

/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The EnumClass class ...
 */
public class EnumClass {

	
	public static void main(String args[]) throws Exception {
		
		Constructor con = SourceType.class.getDeclaredConstructors()[0]; 
		Method[] methods = con.getClass().getDeclaredMethods(); 
		for (Method m : methods) { 
		    if (m.getName().equals("acquireConstructorAccessor")) { 
		        m.setAccessible(true);
		        m.invoke(con, new Object[0]); 
		    } 
		} 
		Field[] fields = con.getClass().getDeclaredFields();
		Object ca = null; 
		for (Field f : fields) { 
		    if (f.getName().equals("constructorAccessor")) { 
		        f.setAccessible(true); 
		        ca = f.get(con); 
		    }
		} 
		Method m = ca.getClass().getMethod( "newInstance", new Class[] { Object[].class }); 
		m.setAccessible(true); 
		SourceType v = (SourceType) m.invoke(ca, new Object[] { new Object[] { "VACATION", Integer.MAX_VALUE } });
		
		System.out.println(v.getClass() + ":" + v.name() + ":" + v.ordinal());

		
	}
	
}
