package edu.northwestern.dasu.dynamic.drools;

import edu.northwestern.dasu.drools.FactProbeResult;
import edu.northwestern.dasu.measurement.types.ProbeType;

public class FactBrowserProbeResult extends FactProbeResult{
	
	public String url = null;
	public int taskId = -1;
	public long timestamp = -1;
	public boolean error = false;
	public String browserType = "";
	public long renderingTime1stNoJs = -1;
	public long renderingTime2ndNoJs = -1;
	public long renderingTime3rdWithJs = -1;
	public String interfaceName = "";
	public String interfaceType;

	public FactBrowserProbeResult(String url) {
		super(ProbeType.valueOf("BROWSER"));
		this.url = url;
	}
	
	public FactBrowserProbeResult(String url, int taskId) {
		super(ProbeType.valueOf("BROWSER"));
		this.url = url;
		this.taskId = taskId;
		
	}

	public FactBrowserProbeResult(String url, int taskId,
			long timestamp, String interfaceName, String interfaceType, String browserType,
			int sequenceNumber, long renderingTime1st, long renderingTime2nd, long renderingTimeNoJs, boolean error) {
		super(ProbeType.valueOf("BROWSER"));
		this.url = url;
		this.taskId = taskId;
		this.timestamp = timestamp;
		this.interfaceName = interfaceName;
		this.interfaceType = interfaceType;
		this.error = error;
		this.browserType = browserType;
		this.renderingTime1stNoJs = renderingTime1st;
		this.renderingTime2ndNoJs = renderingTime2nd;
		this.renderingTime3rdWithJs = renderingTimeNoJs;
	}
	
	public String getUrl() {
		return url;
	}

	public int getTaskId() {
		return taskId;
	}

	public long getTimestamp() {
		return timestamp;
	}

	public boolean isError() {
		return error;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public void setTaskId(int taskId) {
		this.taskId = taskId;
	}

	public void setTimestamp(long timestamp) {
		this.timestamp = timestamp;
	}

	public void setError(boolean error) {
		this.error = error;
	}

	public String getBrowserType() {
		return browserType;
	}

	public void setBrowserType(String browserType) {
		this.browserType = browserType;
	}

	public long getrenderingTime1stNoJs() {
		return renderingTime1stNoJs;
	}

	public void setRenderingTime1stNoJs(long renderingTime1stNoJs) {
		this.renderingTime1stNoJs = renderingTime1stNoJs;
	}

	public long getRenderingTime2ndNoJs() {
		return renderingTime2ndNoJs;
	}

	public void setRenderingTime2ndNoJs(long renderingTime2ndNoJs) {
		this.renderingTime2ndNoJs = renderingTime2ndNoJs;
	}

	public String getInterfaceName() {
		return interfaceName;
	}

	public void setInterfaceName(String interfaceName) {
		this.interfaceName = interfaceName;
	}

	public String getInterfaceType() {
		return interfaceType;
	}

	public void setInterfaceType(String interfaceType) {
		this.interfaceType = interfaceType;
	}

	public long getRenderingTime3rdWithJs() {
		return renderingTime3rdWithJs;
	}

	public void setRenderingTime3rdWithJs(long renderingTime3rdWithJs) {
		this.renderingTime3rdWithJs = renderingTime3rdWithJs;
	}

}
