/**
 * Dasu Project
 *
 * File:         IntervalType.java
 * RCS:          $Id$
 * Description:  IntervalType class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Oct 2, 2010 at 8:31:59 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.measurement
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2010, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

package edu.northwestern.dasu.measurement.types;


/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The TestType class ...
 */

public enum TestType implements EventTypeInterface {
	AZUREUS_UPNP(100,10), 
	AZUREUS_UL(2,2), 
	AZUREUS_DL(2,2), 
	AZUREUS_UL_ENCRYPTION(2,2), 
	AZUREUS_DL_ENCRYPTION(2,2),
	FORCE_SEEDING_THROUGH_PORT(1,1);
	
	private int maxTestsPerHour;
	private int maxTestsPerMin;
	private String type;
	
	TestType(int testsPerHour, int testsPerMinute) {
		maxTestsPerHour = testsPerHour;
		maxTestsPerMin = testsPerMinute;
	}

	public int getMaxPerHour() {
		return maxTestsPerHour;
	}
	
	public int getMaxPerMin() {
		return maxTestsPerMin;
	}

	public String getType() {
		return type;
	}

}