package edu.northwestern.dasu.sandbox.applet;

import java.rmi.*;
import java.rmi.server.*;

import edu.northwestern.dasu.drools.FactTemplate;
import edu.northwestern.dasu.measurement.tasks.ProbeTask;
import edu.northwestern.dasu.measurement.types.SourceType;
import edu.northwestern.dasu.sandbox.mainSandboxedProcess;

public class NotifyRemoteProbeTask extends UnicastRemoteObject implements NotifyInterface {

	private static final long serialVersionUID = 1L;
	
	private ProbeTask probeTask;
    private RmiAMCoordinatorInterface remoteAMC;
    private SourceType engineId;
    private java.util.logging.Logger LOGGER = java.util.logging.Logger.getLogger("edu.northwestern.dasu");

    public NotifyRemoteProbeTask(ProbeTask pt, RmiAMCoordinatorInterface rt, SourceType engine) throws RemoteException {
    	remoteAMC = rt;
    	probeTask = pt;
    	engineId = engine;
    }
    
    public ProbeTask getProbeTask() {
    	return probeTask;
    }
    
    public SourceType getEngineId() {
    	return engineId;
    }
    
    public void doneIt() {
        try {        	        	        	
        	FactTemplate fact = remoteAMC.getResult(this);
        	if ( mainSandboxedProcess.getEngine(engineId) != null)
        		mainSandboxedProcess.getEngine(engineId).addFact(fact);
        }
        catch(Exception e){
        	e.printStackTrace();            
        }
    }

	public Object getParameter() {
		return probeTask;
	}
	    
    
}