package edu.northwestern.dasu.sandbox.applet;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Map;

import edu.northwestern.cs.aqualab.Cattle.json.JSONObject;
import edu.northwestern.dasu.measurement.AMCoordinatorV2Interface;
import edu.northwestern.dasu.measurement.tasks.ProbeTask;
import edu.northwestern.dasu.measurement.types.SourceType;

public class RmiClientAMCoordinatorV2 implements AMCoordinatorV2Interface {
	
	private SourceType engineId;
	private RmiAMCoordinatorInterface remoteAMC;
     
    public RmiClientAMCoordinatorV2(SourceType engineId) {
        
        try {   
        	
        	remoteAMC = (RmiAMCoordinatorInterface) Naming.lookup("rmi://localhost/RmiAMCCoordinator");        	
        	this.engineId = engineId;
        }
        catch(Exception e){
        	e.printStackTrace();
        };        
    }

    public boolean addProbeTask(ProbeTask task) throws RemoteException {
    	
    	task.sourceType = engineId;
    	NotifyRemoteProbeTask notifyProbeTask = new NotifyRemoteProbeTask(task,remoteAMC,engineId);
    	return remoteAMC.nextProbeTask(notifyProbeTask);    	
    }

	public ArrayList<ArrayList<String>> getMyDnsServers() throws RemoteException {
		return (ArrayList<ArrayList<String>>) remoteAMC.syncMethodCall("getMyDnsServers", null);		
	}

	public String getMyPublicIp() throws RemoteException {
		return (String) remoteAMC.syncMethodCall("getMyPublicIp", null);
	}

	public float getPluginVersion() throws Exception {
		return (Float) remoteAMC.syncMethodCall("getPluginVersion", null);
	}

	public void commitFeedback(String type, String name, String email,
			String message, String dump) throws Exception {
		remoteAMC.syncMethodCall("commitFeedback", new Object[]{type, name, email, message, dump});
	}

	public void commitReportableFact(String type, Map<String, Object> values)
			throws Exception {
		remoteAMC.syncMethodCall("commitReportableFact", new Object[]{type, values});
	}
	
	public JSONObject getJSONObjectFromServer(Integer taskId, String resource) 
			throws Exception {
		return (JSONObject) remoteAMC.syncMethodCall("getJSONObjectFromServer", new Object[]{taskId, resource});
	}


}