/**
 * Dasu Project
 *
 * File:         ProbeEventListener.java
 * RCS:          $Id: ProbeEventListener.java,v 1.0 Apr 19, 2011 1:37:25 PM john Exp $
 * Description:  ProbeEventListener class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Apr 19, 2011 at 1:37:25 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.util
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2011, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.util;

import edu.northwestern.dasu.measurement.tasks.ProbeTask;
import edu.northwestern.dasu.measurement.tasks.ProbeTask.ProbeSubTask;

/**
 * @author John Otto &lt;jotto@eecs.northwestern.edu&gt;
 *
 * The ProbeEventListener class ...
 */
public interface ProbeEventListener {

	public void probeQueued(ProbeTask pt); // called when a probe task is submitted to AMC
	
	public void probeScheduled(ProbeSubTask pst); // called when a probe sub task is sent to the module 
	public void probeCompleted(ProbeSubTask pst); // called when a probe sub task comes back from the module	
}
